PROGRAM MagicDemo;

(* Als erstes mssen wir die Module importieren, die wir fr unser
 * Programm bentigen.
 *)

{$E APP}
USES    TOS,
        M_Types,        (* Typ-Definitionen     *)
        M_Sys,          (* Basismodul           *)
        M_Strings,      (* Stringmodul          *)
        M_AES,          (* AES-Interface        *)
        M_VDI,          (* VDI-Interface        *)
        M_Appl,         (* Applikation-Manager  *)
        M_Event,        (* Event-Dispatcher     *)
        M_Messages,     (* Nachrichten          *)
        M_Menus,        (* Menzeilen-Manager   *)
        M_Popups,       (* Popups               *)
        M_Rsc,          (* Resource-Manager     *)
        M_Random,       (* Zufallszahlen        *)
        M_Dials,        (* Dialoge              *)
        M_Utils,        (* Ein paar Werkzeuge   *)
        M_Alerts,       (* Alertdialoge         *)
        M_Terminal,     (* Textfenster          *)
        M_Windows,      (* Fenster-Manager      *)
        M_Fontselector, (* Font-Auswahl         *)
        MagicLines;


(*$I MAGICDEM.I*)

(* Jetzt legen wir unsere globalen Variablen fest. *)
 
VAR     theWindow:      INTEGER;   (* Die Fensternummer *)
        theWindow2:     INTEGER;   (* Die Fensternummer *)
        GraphWin1:      INTEGER;
        GraphWin2:      INTEGER;

VAR     progende:       INTEGER;   (* Flag fr Programmende *)

VAR     rsc:            RESOURCE;  (* Die Resource          *)
        menu:           tObjcTree; (* Objektbaum der Menzeile *)
        dial:           tObjcTree; (* Objektbaum fr den Dialog *)
        edit:           tObjcTree; (* Objektbaum fr Editfeld *)
        slid:           tObjcTree;
        lbox:           tObjcTree;
        buttbox:        tObjcTree;
        strbox:         tObjcTree;
        framebox:       tObjcTree;
        Bbox:           tObjcTree;
        Colicon:        tObjcTree;
        pop1:           tObjcTree;
        pop2:           tObjcTree;
        pop3:           tObjcTree;
        ibutt:          tObjcTree;
        tbox:           tObjcTree;
        actLButton:     INTEGER;
        actLBox:        INTEGER;
        theTimer:       INTEGER; (* ID des Timer-Events *)
        imagecolor:     INTEGER;
        cstr:           CSTRING;
        name:           STRING;
        eff:            BITSET;

(*------------------------------------------------------------------------*)

VAR att: BOOLEAN;

PROCEDURE HandleTimer (para: PtrEP);
VAR s: STRING[20];
    i, j: INTEGER;
BEGIN
  IF WinOpen (theWindow) THEN BEGIN
   CursorOn (theWindow);
   FOR j:= 1 TO 10 DO s[j]:= Chr(M_Random.RndInt(127-32)+32);  s[0]:= CHR(10);
   WriteLine (theWindow, s);
  END;
 (* Die Ausgabe erfolgt ganz einfach mit WriteLine aus dem Modul M_Terminal.
  * Ausgaben ber M_Terminal bercksichtigen alles wichtige, wie zB. die 
  * Rechteckliste des Fensters und geben nur in die sichtbaren Teile des 
  * Fensters aus, auch wenn dieses im Hintergrund liegt.  Zustzlich
  * hat man den Vorteil, da man sich nicht um Redraw-Events kmmern
  * mu, das macht M_Terminal von ganz alleine.
  *)
END (*HandleTimer*);

PROCEDURE QuitAlert (ap: M_Alerts.PtrAlertpara);
BEGIN
 CASE ap^.message OF
  AlertClicked:  IF ap^.objc = 1 THEN  progende:= -1;
  ELSE ;
 END;
END (*QuitAlert*);

PROCEDURE SetBFlags (t: tObjctree; b: BITSET; gem, magic, gback, mback: INTEGER; incl: BOOLEAN);
BEGIN
 IF incl THEN BEGIN
  IF gem > 0   THEN  t^[gem].obFlags:=   t^[gem].obFlags + b;
  IF magic > 0 THEN  t^[magic].obFlags:= t^[magic].obFlags + b;
 END ELSE BEGIN
  IF gem > 0   THEN  t^[gem].obFlags:=   t^[gem].obFlags - b;
  IF magic > 0 THEN  t^[magic].obFlags:= t^[magic].obFlags - b;
 END;
 IF gem > 0   THEN  DialDraw (t, gback, 8, ScreenRect);
 IF magic > 0 THEN  DialDraw (t, mback, 8, ScreenRect);
END (*SetBFlags*);

PROCEDURE SetBState (t: tObjctree; b: BITSET; gem, magic, gback, mback: INTEGER; incl: BOOLEAN);
BEGIN
 IF incl THEN BEGIN
  IF gem > 0   THEN  t^[gem].obState:=   t^[gem].obState + b;
  IF magic > 0 THEN  t^[magic].obState:= t^[magic].obState + b;
 END ELSE BEGIN
  IF gem > 0   THEN  t^[gem].obState:=   t^[gem].obState - b;
  IF magic > 0 THEN  t^[magic].obState:= t^[magic].obState - b;
 END;
 IF gem > 0   THEN  DialDraw (t, gback, 8, ScreenRect);
 IF magic > 0 THEN  DialDraw (t, mback, 8, ScreenRect);
END (*SetBState*);


PROCEDURE ButtonHandler (dp: PtrDialpara);

 PROCEDURE SetObjc (b: BITSET; flag: BOOLEAN);
 BEGIN
  IF flag THEN SetBFlags (dp^.tree, b, Mb_gem, Mb_magic, Mb_gback, Mb_mback, SELECTED IN dp^.tree^[dp^.objc].obState)
          ELSE SetBState (dp^.tree, b, Mb_gem, Mb_magic, Mb_gback, Mb_mback, SELECTED IN dp^.tree^[dp^.objc].obState);
 END (*SetObjc*);

BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 CASE dp^.message OF
  WinClosed:      dp^.action:= [aClose];
  ObjcClicked,
  ObjcDblClicked: CASE dp^.objc OF
                   Mb_ok:        dp^.action:= [aDeselect, aClose];
                   Mb_default:   SetObjc ([DEFAULT ], TRUE);
                   Mb_exit:      SetObjc ([EXITFLAG], TRUE);
                   Mb_radio:     SetObjc ([RBUTTON ], TRUE);
                   Mb_indicator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mb_gem].obFlags:= dp^.tree^[Mb_gem].obFlags + [Bit9] - [Bit10];
                                   dp^.tree^[Mb_magic].obFlags:= dp^.tree^[Mb_magic].obFlags + [Bit14] - [Bit15];
                                  END ELSE BEGIN
                                   dp^.tree^[Mb_gem].obFlags:= dp^.tree^[Mb_gem].obFlags - [Bit9] - [Bit10];
                                   dp^.tree^[Mb_magic].obFlags:= dp^.tree^[Mb_magic].obFlags - [Bit14];
                                  END;
                                  dp^.list^[0]:= Mb_gback; (* Objekt *)
                                  dp^.list^[1]:= 8;        (* Tiefe  *)
                                  dp^.list^[2]:= Mb_mback; (* Objekt *)
                                  dp^.list^[3]:= 8;        (* Tiefe *)
                                  dp^.list^[4]:= -1;       (* Ende der Liste *)
                                  dp^.objc:= Mb_activator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mb_activator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mb_gem].obFlags:= dp^.tree^[Mb_gem].obFlags + [Bit9, Bit10];
                                   dp^.tree^[Mb_magic].obFlags:= dp^.tree^[Mb_magic].obFlags + [Bit15] - [Bit14];
                                  END ELSE BEGIN
                                   dp^.tree^[Mb_gem].obFlags:= dp^.tree^[Mb_gem].obFlags - [Bit9, Bit10];
                                   dp^.tree^[Mb_magic].obFlags:= dp^.tree^[Mb_magic].obFlags - [Bit15];
                                  END;
                                  dp^.list^[0]:= Mb_gback;  dp^.list^[1]:= 8;
                                  dp^.list^[2]:= Mb_mback;  dp^.list^[3]:= 8;
                                  dp^.list^[4]:= -1;
                                  dp^.objc:= Mb_indicator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mb_selected:  SetObjc ([SELECTED], FALSE);
                   Mb_crossed:   SetObjc ([CROSSED ], FALSE);
                   Mb_checked:   SetObjc ([CHECKED ], FALSE);
                   Mb_disabled:  SetObjc ([DISABLED], FALSE);
                   Mb_outlined:  SetObjc ([OUTLINED], FALSE);
                   Mb_shadowed:  SetObjc ([SHADOWED], FALSE);
                   Mb_whitebak:  SetObjc ([WHITEBAK], FALSE);
                   Mb_draw3d:    SetObjc ([DRAW3D  ], FALSE);
                   Mb_state8:    SetObjc ([Bit8    ], FALSE);
                   Mb_state9:    SetObjc ([Bit9    ], FALSE);
                   Mb_state10:   SetObjc ([Bit10   ], FALSE);
                   Mb_state11:   SetObjc ([Bit11   ], FALSE);
                   Mb_state12:   SetObjc ([Bit12   ], FALSE);
                   Mb_state13:   SetObjc ([Bit13   ], FALSE);
                   Mb_state14:   SetObjc ([Bit14   ], FALSE);
                   Mb_state15:   SetObjc ([Bit15   ], FALSE);
                   ELSE          IF (SELECTED IN dp^.tree^[dp^.objc].obState) THEN dp^.action:= [aDeselect, aDraw] 
                                                                              ELSE dp^.action:= [aSelect, aDraw];
                  END;
  ELSE            ;
 END;
END (*ButtonHandler*);

PROCEDURE StringHandler (dp: PtrDialpara);

 PROCEDURE SetObjc (b: BITSET; flag: BOOLEAN);
 BEGIN
  IF flag THEN SetBFlags (dp^.tree, b, Ms_gem, Ms_magic, Ms_gback, Ms_mback, SELECTED IN dp^.tree^[dp^.objc].obState)
          ELSE SetBState (dp^.tree, b, Ms_gem, Ms_magic, Ms_gback, Ms_mback, SELECTED IN dp^.tree^[dp^.objc].obState);
 END (*SetObjc*);

BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 CASE dp^.message OF
  WinClosed:      dp^.action:= [aClose];
  ObjcClicked,
  ObjcDblClicked: CASE dp^.objc OF
                   Ms_ok:        dp^.action:= [aDeselect, aClose];
                   Ms_indicator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Ms_gem].obFlags:= dp^.tree^[Ms_gem].obFlags + [Bit9] - [Bit10];
                                   dp^.tree^[Ms_magic].obFlags:= dp^.tree^[Ms_magic].obFlags - [Bit15] + [Bit14];
                                  END ELSE BEGIN
                                   dp^.tree^[Ms_gem].obFlags:= dp^.tree^[Ms_gem].obFlags + [Bit9] - [Bit10];
                                   dp^.tree^[Ms_magic].obFlags:= dp^.tree^[Ms_magic].obFlags - [Bit14];
                                  END;
                                  dp^.list^[0]:= Ms_gback;  dp^.list^[1]:= 8;
                                  dp^.list^[2]:= Ms_mback;  dp^.list^[3]:= 8;
                                  dp^.list^[4]:= -1;
                                  dp^.objc:= Ms_activator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Ms_activator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Ms_gem].obFlags:= dp^.tree^[Ms_gem].obFlags + [Bit9, Bit10];
                                   dp^.tree^[Ms_magic].obFlags:= dp^.tree^[Ms_magic].obFlags - [Bit14] + [Bit15];
                                  END ELSE BEGIN
                                   dp^.tree^[Ms_gem].obFlags:= dp^.tree^[Ms_gem].obFlags + [Bit9, Bit10];
                                   dp^.tree^[Ms_magic].obFlags:= dp^.tree^[Ms_magic].obFlags - [Bit15];
                                  END;
                                  dp^.list^[0]:= Ms_gback;  dp^.list^[1]:= 8;
                                  dp^.list^[2]:= Ms_mback;  dp^.list^[3]:= 8;
                                  dp^.list^[4]:= -1;
                                  dp^.objc:= Ms_indicator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Ms_selected:  SetObjc ([SELECTED], FALSE);
                   Ms_crossed:   SetObjc ([CROSSED ], FALSE);
                   Ms_checked:   SetObjc ([CHECKED ], FALSE);
                   Ms_disabled:  SetObjc ([DISABLED], FALSE);
                   Ms_outlined:  SetObjc ([OUTLINED], FALSE);
                   Ms_shadowed:  SetObjc ([SHADOWED], FALSE);
                   Ms_whitebak:  SetObjc ([WHITEBAK], FALSE);
                   Ms_draw3d:    SetObjc ([DRAW3D  ], FALSE);
                   Ms_state8:    SetObjc ([Bit8    ], FALSE);
                   Ms_state9:    SetObjc ([Bit9    ], FALSE);
                   Ms_state10:   SetObjc ([Bit10   ], FALSE);
                   Ms_state11:   SetObjc ([Bit11   ], FALSE);
                   Ms_state12:   SetObjc ([Bit12   ], FALSE);
                   Ms_state13:   SetObjc ([Bit13   ], FALSE);
                   Ms_state14:   SetObjc ([Bit14   ], FALSE);
                   Ms_state15:   SetObjc ([Bit15   ], FALSE);
                   ELSE          IF (SELECTED IN dp^.tree^[dp^.objc].obState) THEN dp^.action:= [aDeselect, aDraw] 
                                                                              ELSE dp^.action:= [aSelect, aDraw];
                  END;
  ELSE            ;
 END;
END (*StringHandler*);

PROCEDURE FrameHandler (dp: PtrDialpara);

 PROCEDURE SetObjc (b: BITSET; flag: BOOLEAN);
 BEGIN
  IF flag THEN SetBFlags (dp^.tree, b, -1, Mf_frame, -1, Mf_back, SELECTED IN dp^.tree^[dp^.objc].obState)
          ELSE SetBState (dp^.tree, b, -1, Mf_frame, -1, Mf_back, SELECTED IN dp^.tree^[dp^.objc].obState);
 END (*SetObjc*);

BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 CASE dp^.message OF
  WinClosed:      dp^.action:= [aClose];
  ObjcClicked,
  ObjcDblClicked: CASE dp^.objc OF
                   Mf_ok:        dp^.action:= [aDeselect, aClose];
                   Mf_indicator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mf_frame].obFlags:= dp^.tree^[Mf_frame].obFlags + [Bit14] - [Bit15];
                                  END ELSE BEGIN
                                   dp^.tree^[Mf_frame].obFlags:= dp^.tree^[Mf_frame].obFlags - [Bit14];
                                  END;
                                  dp^.list^[0]:= Mf_back;  dp^.list^[1]:= 8;  dp^.list^[2]:= -1;
                                  dp^.objc:= Mf_activator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mf_activator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mf_frame].obFlags:= dp^.tree^[Mf_frame].obFlags + [Bit15] - [Bit14];
                                  END ELSE BEGIN
                                   dp^.tree^[Mf_frame].obFlags:= dp^.tree^[Mf_frame].obFlags - [Bit15];
                                  END;
                                  dp^.list^[0]:= Mf_back;  dp^.list^[1]:= 8; dp^.list^[2]:= -1;
                                  dp^.objc:= Mf_indicator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mf_selected:  SetObjc ([SELECTED], FALSE);
                   Mf_crossed:   SetObjc ([CROSSED ], FALSE);
                   Mf_checked:   SetObjc ([CHECKED ], FALSE);
                   Mf_disabled:  SetObjc ([DISABLED], FALSE);
                   Mf_outlined:  SetObjc ([OUTLINED], FALSE);
                   Mf_shadowed:  SetObjc ([SHADOWED], FALSE);
                   Mf_whitebak:  SetObjc ([WHITEBAK], FALSE);
                   Mf_draw3d:    SetObjc ([DRAW3D  ], FALSE);
                   Mf_state8:    SetObjc ([Bit8    ], FALSE);
                   Mf_state9:    SetObjc ([Bit9    ], FALSE);
                   Mf_state10:   SetObjc ([Bit10   ], FALSE);
                   Mf_state11:   SetObjc ([Bit11   ], FALSE);
                   Mf_state12:   SetObjc ([Bit12   ], FALSE);
                   Mf_state13:   SetObjc ([Bit13   ], FALSE);
                   Mf_state14:   SetObjc ([Bit14   ], FALSE);
                   Mf_state15:   SetObjc ([Bit15   ], FALSE);
                   ELSE          IF (SELECTED IN dp^.tree^[dp^.objc].obState) THEN dp^.action:= [aDeselect, aDraw] 
                                                                              ELSE dp^.action:= [aSelect, aDraw];
                  END;
  ELSE            ;
 END;
END (*FrameHandler*);


PROCEDURE BoxHandler (dp: PtrDialpara);

 PROCEDURE SetObjc (b: BITSET; flag: BOOLEAN);
 BEGIN
  IF flag THEN SetBFlags (dp^.tree, b, -1, Mx_box, -1, Mx_back, SELECTED IN dp^.tree^[dp^.objc].obState)
          ELSE SetBState (dp^.tree, b, -1, Mx_box, -1, Mx_back, SELECTED IN dp^.tree^[dp^.objc].obState);
 END (*SetObjc*);

BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 CASE dp^.message OF
  WinClosed:      dp^.action:= [aClose];
  ObjcClicked,
  ObjcDblClicked: CASE dp^.objc OF
                   Mx_ok:        dp^.action:= [aDeselect, aClose];
                   Mx_indicator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mx_box].obFlags:= dp^.tree^[Mx_box].obFlags + [Bit14] - [Bit15];
                                  END ELSE BEGIN
                                   dp^.tree^[Mx_box].obFlags:= dp^.tree^[Mx_box].obFlags - [Bit14];
                                  END;
                                  dp^.list^[0]:= Mx_back; dp^.list^[1]:= 8; dp^.list^[2]:= -1;
                                  dp^.objc:= Mx_activator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mx_activator: BEGIN
                                  IF SELECTED IN dp^.tree^[dp^.objc].obState THEN BEGIN
                                   dp^.tree^[Mx_box].obFlags:= dp^.tree^[Mx_box].obFlags + [Bit15] - [Bit14];
                                  END ELSE BEGIN
                                   dp^.tree^[Mx_box].obFlags:= dp^.tree^[Mx_box].obFlags - [Bit15];
                                  END;
                                  dp^.list^[0]:= Mx_back; dp^.list^[1]:= 8; dp^.list^[2]:= -1;
                                  dp^.objc:= Mx_indicator;
                                  dp^.action:= [aDeselect, aDraw, aDrawList];
                                 END;
                   Mx_selected:  SetObjc ([SELECTED], FALSE);
                   Mx_crossed:   SetObjc ([CROSSED ], FALSE);
                   Mx_checked:   SetObjc ([CHECKED ], FALSE);
                   Mx_disabled:  SetObjc ([DISABLED], FALSE);
                   Mx_outlined:  SetObjc ([OUTLINED], FALSE);
                   Mx_shadowed:  SetObjc ([SHADOWED], FALSE);
                   Mx_whitebak:  SetObjc ([WHITEBAK], FALSE);
                   Mx_draw3d:    SetObjc ([DRAW3D  ], FALSE);
                   Mx_state8:    SetObjc ([Bit8    ], FALSE);
                   Mx_state9:    SetObjc ([Bit9    ], FALSE);
                   Mx_state10:   SetObjc ([Bit10   ], FALSE);
                   Mx_state11:   SetObjc ([Bit11   ], FALSE);
                   Mx_state12:   SetObjc ([Bit12   ], FALSE);
                   Mx_state13:   SetObjc ([Bit13   ], FALSE);
                   Mx_state14:   SetObjc ([Bit14   ], FALSE);
                   Mx_state15:   SetObjc ([Bit15   ], FALSE);
                   ELSE          IF (SELECTED IN dp^.tree^[dp^.objc].obState) THEN dp^.action:= [aDeselect, aDraw] 
                                                                              ELSE dp^.action:= [aSelect, aDraw];
                  END;
  ELSE            ;
 END;
END (*BoxHandler*);

PROCEDURE ToolboxHandler (dp: PtrDialpara);
BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 CASE dp^.message OF
  ObjcClicked,
  ObjcDblClicked: CASE dp^.objc OF
                   tb1: BEGIN
                         IF InState (dp^.tree, dp^.objc, SELECTED) THEN INCLUDE (eff, Fat)
                                                                   ELSE EXCLUDE (eff, Fat);
                         SetAttribut (theWindow, eff);
                        END;
                   tb2: BEGIN
                         IF InState (dp^.tree, dp^.objc, SELECTED) THEN INCLUDE (eff, Italic)
                                                                   ELSE EXCLUDE (eff, Italic);
                         SetAttribut (theWindow, eff);
                        END;
                   tb3: BEGIN
                         IF InState (dp^.tree, dp^.objc, SELECTED) THEN INCLUDE (eff, Underline)
                                                                   ELSE EXCLUDE (eff, Underline);
                         SetAttribut (theWindow, eff);
                        END;
                   tbtcol: DropNext (dp^.tree, tbtf);
                   tbhcol: DropNext (dp^.tree, tbhf);
                  END;
  ObjcDroped:     CASE dp^.objc OF 
                   tbtf: ForegroundColor (theWindow, dp^.spec.x);
                   tbhf: BackgroundColor (theWindow, dp^.spec.x);
                  END;

  ELSE            ;
 END;
END (*ToolboxHandler*);

PROCEDURE DialHandler (dp: PtrDialpara);
BEGIN
 dp^.action:= []; (* Zunchstmal nicht reagieren *)
 IF dp^.tree = dial THEN BEGIN
  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];  (* Dialog-Fenster wurde geschlossen! *)
   ObjcClicked,
   ObjcDblClicked: BEGIN
                    IF (dp^.objc = Moremagic) THEN BEGIN
                    (* Mehr-Taste gedrckt *)
                     CallMagic (99);
                    END;
                    dp^.action:= [aDeselect, (* Button zurcksetzen und ... *)
                               aClose];   (* dem Dialoghandler sagen, er knne den
                                           * Dialog nun beenden
                                           *)
                   END;
   ObjcTimer:      BEGIN
                    INC (imagecolor);
                    IF imagecolor = DefaultWS.DefColors THEN imagecolor:= 0;
                    SetObjcColor (dp^.tree, Magiclogo, imagecolor, -1, -1, -1);
                    dp^.objc:= Magiclogo;
                    dp^.action:= [aDraw];
                   END;
  END;

 END ELSE IF dp^.tree = edit THEN BEGIN
  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];
   ObjcClicked,
   ObjcDblClicked: IF dp^.objc = Editok THEN dp^.action:= [aDeselect, aClose];
   ObjcGotCursor:  ;
   ObjcLostCursor: ;
   ObjcEditkey:    dp^.action:= [aAsterik];
   ELSE            ;
  END;
  IF dp^.window > 0 THEN SYSTEM.Write (#7);

 END ELSE IF dp^.tree = slid THEN BEGIN
  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];
   ObjcClicked,
   ObjcDblClicked: IF dp^.objc = SliderOk THEN dp^.action:= [aDeselect, aClose];
   ObjcSlided:     BEGIN  dp^.spec.x:= dp^.spec.w;  dp^.action:= [aSlider, aDrawSlider];  END;
   ObjcPgLeft:     BEGIN  DEC (dp^.spec.x, 100);  dp^.action:= [aSlider, aDrawSlider];  END;
   ObjcPgRight:    BEGIN  INC (dp^.spec.x, 100);  dp^.action:= [aSlider, aDrawSlider];  END;
   ObjcArLeft:     BEGIN  DEC (dp^.spec.x, 10);   dp^.action:= [aSlider, aDrawSlider];  END;
   ObjcArRight:    BEGIN  INC (dp^.spec.x, 10);   dp^.action:= [aSlider, aDrawSlider];  END;
   ELSE            ;
  END;

 END ELSE IF dp^.tree = lbox THEN BEGIN

  
  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];
   ObjcClicked,
   ObjcDblClicked: CASE dp^.objc OF
                    Deselect:    BEGIN
                                  SelectAll (dp^.tree, Listbox1, 0, SELECTED, FALSE);
                                  RedrawListBox (lbox, Listbox1, -1);
                                  dp^.action:= [aDeselect, aDraw];
                                 END;
                    Listboxok:   dp^.action:= [aDeselect, aClose];
                    Checkmode:   BEGIN
                                 IF SELECTED IN lbox^[Checkmode].obState THEN
                                  SetListboxMode (lbox, Listbox1, CheckMulti)
                                 ELSE
                                  SetListboxMode (lbox, Listbox1, SelectMulti);
                                 RedrawListBox (lbox, Listbox1, -1);
                                END;
                   END;
   ObjcEdited:     BEGIN
                    SelectAll (dp^.tree, Listbox1, 0, SELECTED, FALSE);
                    ObjcString (dp^.tree, SearchInput, cstr);
                    SelectMatching (dp^.tree, Listbox1, 0, cstr, SELECTED, TRUE, TRUE);
                    RedrawListBox (lbox, Listbox1, FindSelected (dp^.tree, Listbox1, 0));
                   END;
    OutsideClick:  SYSTEM.Write (#7);
   ELSE            ;
  END;

 END ELSE IF dp^.tree = colicon THEN BEGIN

  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];
   ObjcClicked,
   ObjcDblClicked: IF dp^.objc = Colorok THEN  dp^.action:= [aDeselect, aClose];
   ELSE            ;
  END;

 END ELSE IF dp^.tree = ibutt THEN BEGIN

  CASE dp^.message OF
   WinClosed:      dp^.action:= [aClose];
   ObjcClicked,
   ObjcDblClicked: IF dp^.objc = ibuttok THEN  dp^.action:= [aDeselect, aClose]
                                         ELSE  dp^.action:= [aBell];
   ELSE            ;
  END;
 END;
END (*DialHandler*);


(* Der Handler fr die Fensterereignisse. Im Prinzip regelt M_Windows
 * alles selbst, man muss nur angeben, was man will!  Dies geschieht
 * durch Rckmeldungen an M_Windows mittels der Variablen 'action'.
 *)

PROCEDURE WinHandler (w: PtrWinPara);
BEGIN
 w^.action:= []; (* Erstmal nicht reagieren *)
 CASE w^.message OF
  WinClicked:    BEGIN
                  WriteLine (theWindow, 'Mausklick gekriegt!'); WriteLn (theWindow);
                  w^.action:= [wBell];
                 END;

  WinRedraw:     (* Den Hintergrund des Fensters restauriert M_Windows
                  * selbsttig. Da wir hier auch keine Ausgaben machen
                  * gengt uns das, und wir brauchen auf diese Nachricht
                  * nicht reagieren
                  *);

  WinTopped:     (* Das Fenster wurde getopped. Das besttigen wir *)
                 w^.action:= [wTopped, wCallback];

  WinClosed:     (* Das Fenster wurde geschlossen. *)
                 BEGIN
                  RemoveMUTIMER (theTimer); (* Timer-Event anmelden. Alle 20ms *)
                  w^.action:= [wClose, wCallback];
                  
                  (*DEC (progende);*) (* Und das Programm ist zu Ende *)
                 END;

  WinFulled:     (* Das Fenster wurde auf volle Gre gebracht *)
                 BEGIN
                  w^.extended[0]:=  150; (* Gesamtzahl Spalten *)
                  w^.extended[1]:=    1; (* Erste Position im Fenster *)
                  w^.extended[2]:=   -1; (* Spalten im Fenster *)
                  w^.extended[3]:= 1500; (* Gesamtzahl Zeilen *)
                  w^.extended[4]:=  300; (* Erste Zeile im Fenster *)
                  w^.extended[5]:=   -1; (* Zeilen im Fenster *)
                  w^.action:= [wFulled, wVsUpdate, wHsUpdate];
                 END;

  WinSized:      (* Das Fenster wurde vergrert/verkleinert. Will man
                  * andere Werte, als die gemeldeten, braucht man nur den
                  * Parameter spec verndern
                  *)
                 BEGIN
                  w^.extended[0]:=  150; (* Gesamtzahl Spalten *)
                  w^.extended[1]:=    1; (* Erste Position im Fenster *)
                  w^.extended[2]:=   -1; (* Spalten im Fenster *)
                  w^.extended[3]:= 1500; (* Gesamtzahl Zeilen *)
                  w^.extended[4]:=  300; (* Erste Zeile im Fenster *)
                  w^.extended[5]:=   -1; (* Zeilen im Fenster *)
                  w^.action:= [wSized, wVsUpdate, wHsUpdate, wCallback];
                 END;

  WinMoved:      (* Die Fensterposition wurde verndert. Auch hier gilt das
                  * unter WinSized gesagte
                  *)
                 w^.action:= [wMoved];

  WinBottomed:   (* Fenster in den Hintergrund geklickt *)
                 w^.action:= [wBottomed];
  
  WinChangeFont: (* Fenster hat die CHANGEFONT-Message des Selectors bekommen *)
                 w^.action:= [wChangefont];

  WinIconify:    BEGIN
                  SetWinIcon (w^.window, GetObjcspec (colicon, Coloricon)^.ciconptr);
                  w^.action:= [wIconify];
                 END;
  WinAllIconify: w^.action:= [wAllIconify];
  WinUnIconify:  w^.action:= [wUnIconify];

  ELSE           (* Alles andere ignorieren wir erstmal. *);
 END;
 
 (* Wie Sie sehen, werden die ganzen Aktionen eigentlich nur besttigt.
  * M_Window und das AES machen die ganze Arbeit unter sich aus.
  *)
END (*WinHandler*);

PROCEDURE OpenWin (wname, winfo: STRING; farbe: INTEGER; mn: BOOLEAN);
VAR x: POINTER;
    f, f2: BITSET;
    tl: Wintreelist;
BEGIN

 IF NOT mn THEN BEGIN
  f:= [M_AES.MOVE, M_AES.NAME, INFO, CLOSER, SIZE, M_AES.FULL, VSLIDE, HSLIDE];
  f2:= [];
  x:= NIL;
 END ELSE BEGIN
  f:= [M_AES.MOVE, M_AES.NAME, INFO, CLOSER, SIZE, M_AES.FULL, VSLIDE, HSLIDE, SMALLER];
  f2:= [WinMenu, WinMultiRsc];
  x:= menu;
 END;
 
 tl[0].tree:= x;
 tl[0].xpos:= 0;
 tl[0].ypos:= 0;
 tl[0].mode:= tbUp;

 tl[1].tree:= tbox;
 tl[1].xpos:= 0;
 tl[1].ypos:= tbox^[0].obHeight;
 tl[1].mode:= tbDown;

 tl[2].tree:= NIL;
 

 theWindow:= OpenTextWindow (

                         (* unsere Handleprozedur *)
                         WinHandler, 

                         (* diese Fensterelemente wollen wir *)
                         f, f2,

                         (* XY-Position des Fensters *)
                         -1, -1,

                         (* Breite und Hhe des Fensters *)
                         300, 150,

                         (* Rand-Offsets *)
                         0, 0, 0, 0, 

                         (* Farben *)
                         0,  1,
                         
                         (* Font, Grsse *)
                         100, 10, 
                         
                         (* Effekte *)
                         [],
                         
                         (* Wrap-Position *)
                         75,

                         (* Titelzeile *)
                         wname, 
                         
                         (* Infozeile *)
                         winfo, 
                         
                         (* eventuelle Resource *)
                         @tl);
 INC (progende);
END (*OpenWin*);

PROCEDURE DemoAlert (ap: PtrAlertpara);
BEGIN
 CASE ap^.message OF
  AlertTimer:  Write (#7);
  ELSE ;
 END;
END (*DemoAlert*);

PROCEDURE HandleMenu (mp: PtrMenupara);
VAR i, x, y, win: INTEGER;
    open: BOOLEAN;
    mode: Dialmode;
    pop:  POINTER;
    item: INTEGER;
    pc, nm: PCHAR;
    p, n: CSTRING;
    pf, na: STRING;
BEGIN
 mp^.action:= [];
 CASE mp^.entry OF
  Infodial:   OpenDial (dial, dNonmodal, [], -1, -1, -1, -1, -1, -1, '');
  Buttons:    OpenDial (buttbox, dNonmodal, [], -1, -1, -1, -1, -1, -1, '');
  Strings:    OpenDial (strbox, dNonmodal, [], 1, -1, -1, -1, -1, -1, '');
  Boxes:      OpenDial (bbox, dNonmodal, [], 1, -1, -1, -1, -1, -1, 'Schnabbeldu');
  Editfeld:   BEGIN
               OpenDial (edit, dNonmodal, [dInfo(*, dAllKeys*)], 1, -1, -1, -1, -1, -1, '');
               DialInfo (edit, mode, win, open);
               SetWinInfo (win, 'Hallo du kleines Editfeld!!!');
              END;
  Slider:     OpenDial (slid, dNonmodal, [], -1, -1, -1, -1, -1, -1, 'Schieberdemo');
  Listboxen:  OpenDial (lbox, dmodal, [dLeaveOut], 0, 0, -1, -1, -1, -1, '');
  Frameboxen: OpenDial (framebox, dNonmodal, [], -1, -1, -1, -1, -1, -1, '');
  Coloricons: OpenDial (colicon, dNonmodal, [], -1, -1, -1, -1, -1, -1, '');
  IButton:    OpenDial (ibutt, dNonmodal, [], -1, -1, -1, -1, -1, -1, '');
  Popups:     BEGIN
               M_Popups.Popup (pop1, -1, -1, 0, pop, item);
               IF pop = pop1 THEN BEGIN
                WriteLine (theWindow, 'Tree: pop1 Item: ');  WriteInt (theWindow, item, 0);
               END ELSE IF pop = pop2 THEN BEGIN
                Writeline (theWindow, 'Tree: pop2 Item: ');  WriteInt (theWindow, item, 0);
               END ELSE IF pop = pop3 THEN BEGIN
                Writeline (theWindow, 'Tree: pop3 Item: ');  WriteInt (theWindow, item, 0);
               END ELSE BEGIN
                Writeline (theWindow, 'Undefined...');
               END;
               WriteLn (theWindow);
              END;
  Linesdemo:  TheLines;
  Quit:       WindowAlert (-1, -1, 1, '[2|Magic und PurePascal|2|6][Programm beenden?][.[OK|:[Abbruch]', QuitAlert);
  Runprogram: BEGIN
               (* Quick and Dirty *)
               p[0]:= #0;  n[0]:= #0;
               IF fsel_input (p, n) THEN BEGIN
                pf:= StrPas (p);  i:= Length (pf);
                WHILE pf[i] <> '\' DO BEGIN  pf[i]:= #0;  DEC (i);  END;
                pf[0]:= CHR (i);  pf:= pf + StrPas (n);
                Pexec (0, pf, '', NIL);
               END;
              END;
  Selectfont: BEGIN
               SampleSentence ('Magic 4.00, besser denn je!');
               TermFontselector ('Terminal-Font auswhlen', [fsNonmodal, fsOwntext]);
              END;
  Fensterauf: BEGIN
               IF theWindow < 0 THEN BEGIN
                STR (ApplIdent:3, name);  name:= name + ' <- Applikationsnummer!'#0;
                OpenWin (' Textfenster '#0, name, 12, TRUE);
                WrapOn (theWindow);
                (*WriteLine (theWindow, #27'c'#8);*)
                theTimer:= InstMUTIMER (HandleTimer, 2); (* Timer-Event anmelden. Alle 20ms *)
               END ELSE BEGIN
                theTimer:= InstMUTIMER (HandleTimer, 2); (* Timer-Event anmelden. Alle 20ms *)
                ReopenWin (theWindow);
               END;
               mp^.spec.x:= Fensterauf;
               mp^.spec.y:= Fensterzu;
               mp^.action:= [mSwapDisabled];
              END;
  Fensterzu:  BEGIN
               RemoveMUTIMER (theTimer);
               TempCloseWin (theWindow);
               mp^.spec.x:= Fensterauf;
               mp^.spec.y:= Fensterzu;
               mp^.action:= [mSwapDisabled];
              END;
  Alertbox:   BEGIN
               SetIconslot (6, GetObjcspec (colicon, Coloricon)^.ciconptr);
               WindowAlert (-1, -1, 3,
                            '[6]'+
                             '[%D3D-Effekte im Alert|'+
                             '%FFettgeschriebenes|'+
                             '%ISchrggestelltes|'+
                             '%UUnterstrichenes|'+
                             'Alles ist in Magic mglich...||'+
                             '...|Sogar| bis |zu |4 |Buttons!]'+
                             '[ [Sicher | [Klar | [OK | [Abbruch ]',
                             DemoAlert);
              END;
                                   
 
 
 END;
END (*HandleMenu*);


VAR s, z: STRING;
    r: tRect;

PROCEDURE FillDrop;
VAR i: INTEGER;
BEGIN
 FOR i:= 0 TO 100 DO BEGIN
  MouseRotor;
  Str(i:4, s);  s:= s + ' Dropboxeintrag'#0;
  AddEntry (lbox, Dropbox1, [], NIL, s);
 END;
 SetDropboxElement (lbox, Dropbox1, 0, FALSE);
 (*DisableDropbox (lbox, dropbox1, FALSE);*)
END;

PROCEDURE AddList (t: tObjctree; list, sel: INTEGER);
BEGIN
 AddEntry (t, list, [], NIL, ' Weiss');           (*  0 *)
 AddEntry (t, list, [], NIL, ' Schwarz');         (*  1 *)
 IF DefaultWS.Defcolors > 2 THEN BEGIN
  AddEntry (t, list, [], NIL, ' Rot');             (*  2 *)
  AddEntry (t, list, [], NIL, ' Grn');            (*  3 *)
  IF DefaultWS.Defcolors > 4 THEN BEGIN
   AddEntry (t, list, [], NIL, ' Blau');            (*  4 *)
   AddEntry (t, list, [], NIL, ' Cyan');            (*  5 *)
   AddEntry (t, list, [], NIL, ' Gelb');            (*  6 *)
   AddEntry (t, list, [], NIL, ' Magenta');         (*  7 *)
   AddEntry (t, list, [], NIL, ' Grau');            (*  8 *)
   AddEntry (t, list, [], NIL, ' Dunkelgrau');      (*  9 *)
   AddEntry (t, list, [], NIL, ' Dunkelrot');       (* 11 *)
   AddEntry (t, list, [], NIL, ' Dunkelgrn');      (* 12 *)
   AddEntry (t, list, [], NIL, ' Dunkelblau');      (* 13 *)
   AddEntry (t, list, [], NIL, ' Dunkelcyan');      (* 14 *)
   AddEntry (t, list, [], NIL, ' Dunkelgelb');      (* 15 *)
   AddEntry (t, list, [], NIL, ' Dunkelmagenta');   (* 16 *)
  END;
 END;
 SetDropboxElement (t, list, sel, FALSE);
END (*AddList*);


VAR menid: INTEGER;
    mid:   INTEGER;
    pid:   INTEGER;
    np:    PCHAR;
    b:     BOOLEAN;
    term:  INTEGER;
    i, j:  INTEGER;
    cs:    CSTRING;


BEGIN
 (* Programmnamen setzen *)
 ProgName ('Magic-Pascal-Demo'#0);
 (* Abspanndialog aus *)
 App^.MagicPB^.IntIn[0]:= 1;  CallMagic (98);
 eff:= [];
 imagecolor:= 1;
 term:= -1;
 MouseOn;

 IF LoadRsc ('MAGICDEM.RSC', rsc) THEN BEGIN
  menu:= GaddrRsc (rsc, RTREE, Menutree);    (* Objektbume ermitteln *)

  InitMenuline (menu, HandleMenu, TRUE);
  InstallDeskMenu (menu);

  dial:= GaddrRsc (rsc, RTREE, InfoDialog);
  MagicVerString (cs);
  StrInsert ('Magic '#0, cs, 0);
  SetObjcStringAdr (dial, Release, @cs);  

  edit:= GaddrRsc (rsc, RTREE, EditDialog);
  slid:= GaddrRsc (rsc, RTREE, SliderDialog);
  lbox:= GaddrRsc (rsc, RTREE, ListboxDialog);
  buttbox:= GaddrRsc (rsc, RTREE, MagicButtons);
  strbox:= GaddrRsc (rsc, RTREE, MagicStrings);
  framebox:= GaddrRsc (rsc, RTREE, MagicFrames);
  bbox:= GaddrRsc (rsc, RTREE, MagicBoxes);
  colicon:= GaddrRsc (rsc, RTREE, Farbicons);
  pop1:= GaddrRsc (rsc, RTREE, Popup);
  pop2:= GaddrRsc (rsc, RTREE, Subpop1);
  pop3:= GaddrRsc (rsc, RTREE, Subpop2);
  ibutt:= GaddrRsc (rsc, RTREE, Iconbutton);
  tbox:= GaddrRsc (rsc, RTREE, Toolbox);

  AttachPopup (pop1, pop2, 5);
  AttachPopup (pop1, pop3, 7);
  AttachPopup (pop2, pop3, 3);

  NewDial (dial, DialHandler); (* Dialoge initialisieren *)
  NewDial (edit, DialHandler);
  NewDial (slid, DialHandler);
  NewDial (lbox, DialHandler);
  NewDial (buttbox, ButtonHandler);
  NewDial (strbox, StringHandler);
  NewDial (framebox, FrameHandler);
  NewDial (bbox, BoxHandler);
  NewDial (colicon, Dialhandler);
  NewDial (ibutt, Dialhandler);
  NewDial (tbox, ToolboxHandler);

  SetUserkey (lbox, Sliderup, F1, TRUE, TRUE);
  SetUserkey (lbox, Sliderup, ShF1, TRUE, TRUE);
  SetUserkey (lbox, Sliderup, CtrlF1, TRUE, TRUE);
  SetUserkey (lbox, Sliderdown, F2, TRUE, TRUE);
  SetUserkey (lbox, Sliderdown, ShF2, TRUE, TRUE);
  SetUserkey (lbox, Sliderdown, CtrlF2, TRUE, TRUE);
  SetUserkey (lbox, Slup, F3, TRUE, TRUE);
  SetUserkey (lbox, Slup, ShF3, TRUE, TRUE);
  SetUserkey (lbox, Slup, CtrlF3, TRUE, TRUE);
  SetUserkey (lbox, Sldown, F4, TRUE, TRUE);
  SetUserkey (lbox, Sldown, ShF4, TRUE, TRUE);
  SetUserkey (lbox, Sldown, CtrlF4, TRUE, TRUE);

  SetUserkey (tbox, tb1, AltF, TRUE, TRUE);
  SetUserkey (tbox, tb2, AltI, TRUE, TRUE);
  SetUserkey (tbox, tb3, AltU, TRUE, TRUE);

  SetSlider (slid, VSlider, 0, 100);
  SetSlider (slid, HSlider, 0, 100);

  AddList (tbox, tbtf, 1);
  AddList (tbox, tbhf, 0);

  FillDrop;

  FOR i:= 0 TO 100 DO BEGIN
   MouseRotor;
   FillChar (s, SIZEOF (s), #0);
   FOR j:= 0 TO 21 DO  s[j]:= CHR (RndInt (96) + 32);
   AddEntry (lbox, Listbox1, [], NIL, s);
  END;

  FOR i:= 0 TO 5 DO BEGIN
   MouseRotor;
   Str(i:4, s);  s:= s + ' Listboxeintrag'#0;
   AddEntry (lbox, Listbox2, [], NIL, s);
  END;
  {
  InsertEntry (lbox, Listbox2, 50, [], NIL, 'InsertEntry'#0);
  ChangeEntry (lbox, Listbox2, 25, [], NIL, 'ChangeEntry'#0);
  }
  SelectEntry (lbox, Listbox2, 3, SELECTED, TRUE);
  CallMagic (99);  (* Copyrightdialog *)

  MouseArrow;

  theWindow:= -1;
  progende:= 1;  (* Damit die Dispatcherschleife auch dauernd durchlaufen
                  * wird.  Sonst funkts ja nicht...
                  *)


  (* Zentrale Dispatcherschleife.
   * Solange Events verarbeiten, bis progende TRUE wird.
   *)
  REPEAT
   CentralDispatcher;
  UNTIL progende < 1;

  term:= 0;
 END ELSE BEGIN
  Alert (-1, -1, 1, '[2|Magic und PurePascal|2][RSC-Datei nicht gefunden!!!][ [Abbruch ]');
 END;
 ApplTerm (term); (* Meldet alles ab, schliet alle offenen Fenster usw. *)
END (*WinDemo*).
