UNIT MagicLines;

(* Atari Demo: Bouncing lines *)

(* --------------------------------------------------------------- *
 * (c) Copyright Modula 2 Software Ltd 1986.  All rights reserved. *
 * --------------------------------------------------------------- *
 * (c) Copyright TDI Software Inc 1985, 1986. All rights reserved. *
 * --------------------------------------------------------------- *
 *         Portiert auf MAGICLIB by Peter Hellinger  06.01.91      *
 * --------------------------------------------------------------- *
 *   Portiert nach Pascal, angepasst an Magic 4.00   04.08.93/Hp   *
 * --------------------------------------------------------------- *)

INTERFACE

PROCEDURE TheLines;

IMPLEMENTATION

USES    M_Types,     (* Typ-definitionen     *)
        M_AES,          (* AES-Funktionen       *)
        M_VDI,          (* VDI-Funktionen       *)
        M_Appl,         (* Applikation-Manager  *)
        M_Event,        (* Event-Dispatcher     *)
        M_Messages,     (* Nachrichten          *)
        M_Random,       (* Zufallszahlen        *)
        M_Windows;      (* Fenster-Manager      *)


VAR     GraphWin:       INTEGER; (* Das Fenster *)
        TimerId:        INTEGER;

CONST   maxLines =        30;
        (*maxDrawLines =    4000;*)

TYPE    LineDescr =       ARRAY [0..3] OF INTEGER;

VAR     Ball, Vel, max:   LineDescr;
        maxX, maxY, min:  INTEGER;
        _Lines:            ARRAY [0..maxLines-1] OF LineDescr;
        index, t, i, new, old, ii, color, colcount: INTEGER;
        r: tRect;
        fback: INTEGER;


PROCEDURE DrawLines;
BEGIN
 IF (new >= maxLines) THEN  BEGIN       (* undraw old line *)
  vsl_color (DefaultWS.handle, fback);
  v_pline (DefaultWS.handle, 2, ADDR (_Lines[old MOD maxLines]));
  INC (old);
 END;
 _Lines[new MOD maxLines]:= Ball;  (* draw new line *)
 INC (new);
 vsl_color (DefaultWS.handle, color);
 v_pline (DefaultWS.handle, 2, ADDR (Ball));
END (*DrawLines*);

PROCEDURE HandleTimer (para: PtrEP);
VAR i, f: INTEGER;
    re, a, r1, r2: tRect;
BEGIN
 IF GraphWin > 0 THEN BEGIN
  IF NOT WinIconified (GraphWin) THEN BEGIN
   FOR i:= 0 TO 3 DO BEGIN
    t:= Ball[i] + Vel[i];
    IF t >= max[i] THEN BEGIN
     t:= max[i] * 2 - Vel[i] - Ball[i];
     Vel[i]:= - Vel[i];
    END;
    IF ODD(i) THEN  min:= r.y  ELSE  min:= r.x;
    IF t < min THEN BEGIN
     IF t < 0 THEN  t:= - t  ELSE  t:= min;
     Vel[i]:= - Vel[i];
    END;
    Ball[i]:= t;
   END; (* FOR *)
  
   RewriteWindow (Graphwin, DefaultWS.handle, DrawLines);
   (* Linien ausgeben *)

   INC (colcount);
   IF colcount > 10 THEN BEGIN
    INC (color);
    IF color >= DefaultWS.Defcolors THEN  color:= 0;
    IF color = fback THEN  INC (color);
    colcount:= 0;
   END;
  END;
 END;
END (*HandleTimer*);

PROCEDURE WinHandler (w: PtrWinPara);
BEGIN
 w^.action:= []; (* Erstmal nicht reagieren *)
 CASE w^.message OF
  WinRedraw:     BEGIN  TheLines;  END;
  WinTopped:     BEGIN  w^.action:= [wTopped];  END;
  WinClosed:     BEGIN
                  GraphWin:= -1;
                  RemoveMUTIMER (TimerId);
                  w^.action:= [wClose];
                 END;
  WinFulled:     BEGIN  TheLines;  w^.action:= [wFulled];  END;
  WinSized:      BEGIN  TheLines;  w^.action:= [wSized];   END;
  WinMoved:      BEGIN  
                  SetWinPos (GraphWin, w^.spec.x, w^.spec.y);
                  TheLines;
                 END;
  WinBottomed:   w^.action:= [wBottomed];
  WinIconify:    w^.action:= [wIconify];
  WinAllIconify: w^.action:= [wAllIconify];
  WinUnIconify:  w^.action:= [wUnIconify];
 END;
END (*WinHandler*);


PROCEDURE TheLines;
VAR I: INTEGER;
BEGIN
 IF GraphWin < 0 THEN BEGIN
  (* M_VDI.vswr_mode (DefaultWS.handle, XORMODE); *)
  GraphWin:= OpenWindow (WinHandler,
                         [M_AES.Move, NAME, CLOSER, SIZE, M_AES.FULL, SMALLER], [],
                         fback, 7, -1, -1, 250, 200, 0, 0, 0, 0,
                         ' The Lines '#0, ' '#0, NIL, NIL);
  TimerId:= InstMUTIMER (HandleTimer, 10); (* Timer-Event anmelden. Alle 20ms *)
 END;
 GetUseableRect (GraphWin, r);
 maxX:= r.x + r.w;
 maxY:= r.y + r.h;
 max[0]:= maxX;
 max[1]:= maxY;
 max[2]:= maxX;
 max[3]:= maxY;
 FOR i:= 0 TO 3 DO BEGIN
  Vel[i]:= RndInt (16) - 8;
  ii:= max[i] - 100;
  Ball[i]:= RndInt (ii) + 50;
 END;
 new:= 0;
 old:= 0;
END (*TheLines*);

BEGIN
 GraphWin:= -1;
 colcount:= 0;
 IF DefaultWS.Defcolors > 2 THEN  fback:= 1 ELSE fback:= 0;
 IF color = fback THEN INC (color);
END (*MagicLines*).
