Unit MyString;

Interface

Uses M_Strings, M_UTils, M_AES, M_Convert, M_TIME, M_DIALS, M_WINDOWS;

Type	Str08	= String[8];
		Str10	= String[10];
		Str16	= String[16];
		Str20	= String[20];
		Str30	= String[30];
		Str24	= String[24];
		Str32	= String[32];
		Str40	= String[40];
		Str48	= String[48];
		Str50	= String[50];
		Str56	= String[56];
		Str64	= String[64];
		Str70	= String[70];
		Str72	= String[72];
		Str80	= String[80];
		Str88	= String[88];
		Str90	= String[90];
		Str96	= String[96];
		Str100	= String[100];
		Str104	= String[104];
		Str110	= String[110];
		Str112	= String[112];
		Str120	= String[120];
		Str128	= String[128];

Procedure PutStr( Tree : Pointer; idx : Integer; s : String );
Procedure GetStr( Tree : Pointer; Idx : Integer; Var s : String );
Procedure PutInt( Tree : Pointer; Idx : Integer; i : Integer );
Procedure PutLong( Tree : Pointer; Idx : Integer; i : LongInt );
Procedure GetInt( Tree : Pointer; Idx : Integer; Var i : Integer );
Procedure GetLong( Tree : Pointer; Idx : Integer; Var i : LongInt );
Procedure PutBool( Tree : Pointer; Idx : Integer; B : Boolean );
Procedure GetBool( Tree : Pointer; Idx : Integer; VAR B : Boolean );
Procedure Trim( var x : String );
Procedure NullSpc( var x : String );
Procedure WriteInfo( P : Pointer; s : Str80 );

Function ToTosTime( Stunde, Minute : Word ) : Word;
Function TosTime( s : String ) : Word;
Function TimeStrMi( W : Word ) : Str10;
Function TimeStr( W : Word ) : Str10;
Function DateStr( W : Word ) : Str10;
Function TosDate( S : Str16 ) : Word;
Function ExtractNum( s : String ) : String;
Function StrUpr( s : String ) : String;
Function StrTok( var s : String; Deli : Char ) : String;

Implementation

Procedure PutStr;
var cstr : Array[0..255] of Char;
Begin
	StrPcopy( cstr, s );
	Setobjcstring( tree, idx, cstr );
end;

Procedure  GetStr;
var cstr : Array[0..255] of Char;
Begin
	s := '';
	Objcstring( tree, idx, cstr );
	if cstr[0] <> #0 Then S := StrPas( Cstr );
End;

Procedure PutInt;
Var s : Str08;
Begin
	Str( i, s );
	PutStr( Tree, Idx, s );
End;

Procedure PutLong;
var	s : Str16;
Begin
	Str( i, s );
	PutStr( Tree, Idx, s );
End;

Procedure GetInt;
var s : Str08;
Begin
	GetStr( Tree, Idx, s );
	Trim( s );
	i := StrToInt( s );
End;

Procedure GetLong;
var s : Str16;
Begin
	GetStr( Tree, Idx, s );
	Trim( s );
	i := StrToLint( s );
End;

Procedure PutBool;
Begin
	SetState( Tree, Idx, M_AES.SELECTED, b );
End;

Procedure GetBool;
Begin
	b := InState( Tree, Idx, M_AES.SELECTED );
End;

Procedure Trim;
var i : Integer;
Begin
	while Length( x ) > 0 Do
	Begin
		i := Pos( ' ', x );
		if i = 0 Then Break;
		Delete( x, i, 1 );
	End;
End;

Function ToTosTime;
Begin
	ToTosTime := EncodeTime( Stunde, Minute, 0 );
End;

Function TosTime;
var	y : Str08;
	_s, _m : Word;

Begin
	y := Copy( s, 1, 2 );
	_m := 0;
	Delete( s, 1, 2 );
	Trim( y );
	_s := StrToInt( y );
	if s <> '' Then
	Begin
		Trim( s );
		_M := StrToInt( s );
	End;
	TosTime := ToTosTime( _S, _M );
End;

Function TimeStr;
var Hr, Mi, Se : Word;
	s, x	   : Str10;
Begin
	DecodeTime( W, Hr, Mi, Se );
	Str( Hr:2, s );
	Str( Mi:2, x );
	s := s + x;
	Str( Se:2, x );
	s := s + x;

	Repeat
		Se := Pos(' ', s );
		if Se > 0 Then s[Se] := '0';
	Until Se = 0;
	TimeStr := s;
End;

Function TimeStrMi;
Begin
	TimeStrMi := Copy( TimeStr( w ), 1, 4 );
End;

Function DateStr;
var Day, Mon, Year	: Word;
	s, x			: Str10;
Begin
	DecodeDate( w, Day, Mon, Year );
	Str( Day:2, s );
	Str( Mon:2, x );
	s := s + x;
	Str( Year:4, x );
	s := s + x;
	
	Repeat
		Day := Pos(' ', s );
		if Day > 0 Then s[Day] := '0';
	Until Day = 0;
	DateStr := s;
End;

Function TosDate;
var Day, Mon, Year : Word;
	x : String;
Begin
	While Length( s ) < 16 Do s := s + ' ';
	x := Copy( s, 1, 2 );
	Delete( s, 1, 2 );
	Trim( x );
	Day := StrToInt( x );

	x := Copy( s, 1, 2 );
	Delete( s, 1, 2 );
	Trim( x );
	Mon := StrToInt( x );

	Trim( s );
	Year := StrToInt( s );
	TosDate := EncodeDate( Day, Mon, Year );
End;

Procedure WriteInfo;
var Mode	: DialMode;
	Win		: Integer;
	IsOpen	: Boolean;
Begin
	DialInfo( p, Mode, Win, IsOpen );
	if IsOpen Then SetWinInfo( Win, s );
End;

Procedure NullSpc;
var i : Integer;
Begin
	i := Pos( ' ', x );
	while i > 0 Do
	Begin
		x[i] := '0';
		i := Pos(' ', x );
	End;
End;

Function ExtractNum;
var x : String;
Begin
	x := '';
	while ( s > '' ) and Not ( s[1] in ['0'..'9'] ) Do Delete( s, 1, 1 );
	
	while( s > '' ) and ( s[1] in ['0'..'9'] ) do
	Begin
		x := x + s[1];
		delete( s, 1, 1 );
	End;
	ExtractNum := x;
End;

Function StrUpr;
var i : Byte;
Begin
	for i := 1 to Length( s ) Do S[i] := Upcase( s[i] );
	StrUpr := s;
End;

Function StrTok;
var x : String;
Begin
	x := '';
	while s > '' Do
	Begin
		if s[1] = Deli Then
		Begin
			Delete( s, 1, 1 );
			Break;
		End;
		
		x := x + s[1];
		delete( s, 1, 1 );
	End;
	StrTok := x;
End;

Begin
End.
