PROGRAM WinHello;

USES    M_Types,        (* Typ-definitionen     *)
        M_AES,          (* AES-Interface        *)
        M_Appl,         (* Applikation-Manager  *)
        M_Event,        (* Event-Dispatcher     *)
        M_Messages,     (* Nachrichten          *)
        M_Terminal,     (* Textfenster          *)
        M_Windows;      (* Fenster-Manager      *)

VAR FirstWin,
    SecondWin,
    ThirdWin    : INTEGER;
    ProgEnde    : INTEGER;

PROCEDURE WinHandler (w: PtrWinPara);

BEGIN
 w^.action   := [];
 CASE w^.message OF
  WinRedraw:     ;
  WinTopped:     w^.action := [wTopped];
  WinClosed:     BEGIN  w^.action := [wClose];  DEC (ProgEnde);  END;
  WinFulled:     w^.action := [wFulled];
  WinSized:      w^.action := [wSized];
  WinMoved:      w^.action := [wMoved];
  WinBottomed:   w^.action := [wBottomed];
  WinIconify:    w^.action := [wIconify];
  WinChangeFont: BEGIN
                  WriteInt (w^.window, w^.window, 0);
                  WriteLn (w^.window);  
                  w^.action:= [wChangefont];
                 END;
  WinUniconify:  w^.action := [wUniconify];
  WinAlliconify: w^.action := [wAlliconify];
  ELSE (* Ignorieren *);
 END;
END;


FUNCTION OpenWin (  wname, winfo    : STRING;
                    farbe           : INTEGER;
                    mn              : BOOLEAN;
                    xPos, yPos      : INTEGER;
                    Breite, Hoehe   : INTEGER;
                    wrap            : INTEGER) : INTEGER;

VAR x   : POINTER;
    f   : BITSET;

BEGIN
   f := [M_AES.MOVE, NAME, CLOSER, FULL, INFO, M_AES.SIZE, SMALLER];
   x := NIL;

    OpenWin := OpenTextWindow ( WinHandler,
                                f, [],
                                xPos, yPos,
                                Breite, Hoehe,
                                0, 0, 0, 0,     (* Offsets *)
                                0, 1,           (* Farben *)
                                100, 10,         (* Font,Gre *)
                                [],             (* Effekte *)
                                wrap,           (* Umbruch *)
                                wname,          (* Titel *)
                                winfo,          (* Infozeile *)
                                x);             (* Ressource *)
    INC (ProgEnde)
END;

VAR name    : STRING;
    term    : INTEGER;

BEGIN
    MouseOn;
    MouseArrow;
    Progende := 0;
    STR (ApplIdent:3, name); name := name + ' <- Applikationsnummer!'#0;
    FirstWin:=  OpenWin (' Hello World 1 '#0, name, 12, FALSE, 100, 100, 250, 150, 50);
    SecondWin:= OpenWin (' Hello World 2 '#0, name, 12, FALSE, 400, 300, 200, 100, 50);
    ThirdWin := OpenWin (' Hello World 3 '#0, name, 12, FALSE, 200, 150, 200, 100, 50);
    WriteLine (FirstWin, 'Hello World');  WriteLn (FirstWin);
    WriteLine (SecondWin, 'Hello World'); WriteLn (SecondWin);
    WriteLine (ThirdWin, 'Hello World');  WriteLn (ThirdWin);
    REPEAT
     CentralDispatcher;
    UNTIL ProgEnde < 1;

    term := 0;
    ApplTerm (term)
END.
