(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.05.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
UNIT M_Alerts;

INTERFACE

USES M_AES;

TYPE PtrAlertpara = ^Alertpara;
     Alertpara =    RECORD
                     message: INTEGER;
                     objc:    INTEGER;
                    END;

TYPE AlertHandler = PROCEDURE (dp: PtrAlertpara);

FUNCTION  Alert (x, y, def: INTEGER; str: STRING): INTEGER;
PROCEDURE WindowAlert (x, y, def: INTEGER; str: STRING; handler: AlertHandler);
PROCEDURE SetIconColor (fcolor, bcolor: INTEGER);
FUNCTION  Iconslot (slotnum: INTEGER): PtrCICONBLK;
PROCEDURE SetIconslot (slotnum: INTEGER; icon: PtrCICONBLK);

IMPLEMENTATION

USES M_Sys, M_Strings;

{$I COMPOPT.INC}

VAR cs: ARRAY [0..1024] OF CHAR;

FUNCTION Alert (x, y, def: INTEGER; str: STRING): INTEGER;
VAR a: ^POINTER;
BEGIN
 Alert:= -1;
 StrPCopy (cs, str);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.AddrIn[1]:= NIL;
 App^.MagicPB^.Intin[0]:= def;
 App^.MagicPB^.Intin[1]:= x;
 App^.MagicPB^.Intin[2]:= y;
 App^.MagicPB^.Intin[3]:= ORD ((x > 0) OR (y >0));
 App^.MagicPB^.Intin[4]:= 1;
 CallMagic (500);
 Alert:= App^.MagicPB^.IntOut[0];
END (*Alert*);

PROCEDURE WindowAlert (x, y, def: INTEGER; str: STRING; 
                       handler: AlertHandler);
VAR c: RECORD
        CASE INTEGER OF
         0: (ptr: POINTER);
         1: (hnd: AlertHandler);
       END;
BEGIN
 c.hnd:= handler;
 StrPCopy (cs, str);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.AddrIn[1]:= c.ptr;
 App^.MagicPB^.Intin[0]:= def;
 App^.MagicPB^.Intin[1]:= x;
 App^.MagicPB^.Intin[2]:= y;
 App^.MagicPB^.Intin[3]:= ORD ((x > 0) OR (y >0));
 App^.MagicPB^.Intin[4]:= 0;
 CallMagic (500);
END (*WindowAlert*);

PROCEDURE SetIconColor (fcolor, bcolor: INTEGER);
BEGIN
 App^.MagicPB^.Intin[0]:= fcolor;
 App^.MagicPB^.Intin[1]:= bcolor;
 CallMagic (502);
END (*SetIconColor*);

FUNCTION Iconslot (slotnum: INTEGER): PtrCICONBLK;
BEGIN
 App^.MagicPB^.Intin[0]:= slotnum;
 CallMagic (503);
 IconSlot:= App^.MagicPB^.AddrOut[0];
END (*IconSlot*);

PROCEDURE SetIconslot (slotnum: INTEGER; icon: PtrCICONBLK);
BEGIN
 App^.MagicPB^.AddrIn[0]:= icon;
 App^.MagicPB^.Intin[0]:= slotnum;
 CallMagic (504);
END (*SetIconSlot*);

END (*M_Alert*).