(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.05.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
UNIT M_Convert;

INTERFACE

PROCEDURE NumToStr (num: LONGINT; len, base: INTEGER; neg: BOOLEAN; VAR s: STRING);
FUNCTION StrToNum (s: STRING; base: INTEGER; neg: BOOLEAN; max: LONGINT): LONGINT;
FUNCTION StrToInt      (s: STRING): INTEGER;
FUNCTION StrToLInt     (s: STRING): LONGINT;
FUNCTION HexToInt      (s: STRING): INTEGER;
FUNCTION HexToLInt     (s: STRING): LONGINT;
FUNCTION StrToReal     (s: STRING): REAL;
PROCEDURE IntToStr      (v: INTEGER; n: INTEGER; VAR s: STRING);
PROCEDURE IntToHexStr   (v: INTEGER; n: INTEGER; VAR s: STRING);
PROCEDURE LIntToStr     (v: LONGINT; n: INTEGER; VAR s: STRING);
PROCEDURE LIntToHexStr  (v: LONGINT; n: INTEGER; VAR s: STRING);
PROCEDURE RealToStr     (v: REAL;    n: INTEGER; VAR s: STRING);

IMPLEMENTATION

{$I COMPOPT.INC}

USES M_Types, M_Sys, M_Strings;

VAR cs: CSTRING;

PROCEDURE NumToStr (num: LONGINT; len, base: INTEGER; neg: BOOLEAN; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR(cs);
 App^.MagicPB^.LongIn[0]:= num;
 App^.MagicPB^.IntIn[0]:= len;
 App^.MagicPB^.IntIn[1]:= base;
 App^.MagicPB^.IntIn[2]:= ORD(neg);
 CallMagic (100);
 s:= StrPas (cs);
END (*NumToStr*);

FUNCTION StrToNum (s: STRING; base: INTEGER; neg: BOOLEAN; max: LONGINT): LONGINT;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR(cs);
 App^.MagicPB^.IntIn[0]:= base;
 App^.MagicPB^.IntIn[1]:= ORD (neg);
 App^.MagicPB^.LongIn[0]:= max;
 CallMagic (101);
 StrToNum:= App^.MagicPB^.LongOut[0];
END (*StrToNum*);

PROCEDURE RealToStr (v: REAL; n: INTEGER; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR (v);
 App^.MagicPB^.AddrIn[1]:= ADDR (cs);
 App^.MagicPB^.IntIn[0]:= n;
 CallMagic (111);
 s:= StrPas (cs);
END (*RealToStr*);

FUNCTION StrToReal (s: STRING): REAL;
VAR r: REAL;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR(r);
 App^.MagicPB^.AddrIn[1]:= ADDR (cs);
 CallMagic (106);
 StrToReal:= r;
END (*StrToReal*);

FUNCTION StrToInt (s: STRING): INTEGER;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 CallMagic (102);
 StrToInt:= App^.MagicPB^.IntOut[0];
END (*StrToInt*);

FUNCTION StrToLInt (s: STRING): LONGINT;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 CallMagic (103);
 StrToLInt:= App^.MagicPB^.LongOut[0];
END (*StrToLInt*);

FUNCTION HexToInt (s: STRING): INTEGER;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 CallMagic (104);
 HexToInt:= App^.MagicPB^.IntOut[0];
END (*HexToInt*);

FUNCTION HexToLInt (s: STRING): LONGINT;
BEGIN
 StrPCopy (cs, s);
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 CallMagic (105);
 HexToLInt:= App^.MagicPB^.LongOut[0];
END (*HexToLInt*);

PROCEDURE IntToStr (v: INTEGER; n: INTEGER; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.IntIn[0]:= v;
 App^.MagicPB^.IntIn[1]:= n;
 CallMagic (107);
 s:= StrPas (cs);
END (*IntToStr*);

PROCEDURE IntToHexStr (v: INTEGER; n: INTEGER; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.IntIn[0]:= v;
 App^.MagicPB^.IntIn[1]:= n;
 CallMagic (108);
 s:= StrPas (cs);
END (*IntToHexStr*);

PROCEDURE LIntToHexStr (v: LONGINT; n: INTEGER; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.LongIn[0]:= v;
 App^.MagicPB^.IntIn[0]:= n;
 CallMagic (110);
 s:= StrPas (cs);
END (*LIntToHexStr*);

PROCEDURE LIntToStr (v: LONGINT; n: INTEGER; VAR s: STRING);
BEGIN
 App^.MagicPB^.AddrIn[0]:= ADDR (cs);
 App^.MagicPB^.LongIn[0]:= v;
 App^.MagicPB^.IntIn[0]:= n;
 CallMagic (109);
 s:= StrPas (cs);
END (*LIntToStr*);

END (*M_Convert*).
