(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.05.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
UNIT M_Fontselector;

INTERFACE

USES M_Types;

CONST fsFlydial =      Bit0;   (* Normaler Dialog                 *)
      fsModal =        Bit1;   (* Selektor in Fenster             *)
      fsNonmodal =     Bit2;   (* Selektor ist nicht-modal        *)
      fsMonospaced =   Bit3;   (* Nur monospaced Fonts            *)
      fsEffect =       Bit4;   (* Texteffekte auswhlen           *)
      fsColor =        Bit5;   (* Farbe auswhlen                 *)
      fsRotation =     Bit6;   (* Rotation einstellen             *)
      fsWidth =        Bit7;   (* Breite bei FSM-Fonts einstellen *)
      fsSpeedoOnly =   Bit8;   (* Nur Speedofonts anzeigen        *)
      fsBitmapOnly =   Bit9;   (* Nur Speedofonts anzeigen        *)
      fsTruetypeOnly = Bit10;  (* Nur Truetypefonts anzeigen      *)
      fsType1Only =    Bit11;  (* Nur Type1-Fonts zulassen        *)
      fsFixType =      Bit12;  (* Typselektion nicht zulassen     *)
      fsOwntext =      Bit13;  (* Eigenen Text in die Auswahlbox  *)

PROCEDURE SampleSentence (CONST txt: STRING);
PROCEDURE FontSelector (handle: INTEGER; CONST msg: STRING; opt: BITSET);
PROCEDURE FontPSelector (handle, x, y: INTEGER; CONST msg: STRING; opt: BITSET);
PROCEDURE CloseSelector;
PROCEDURE RedrawSelector;
PROCEDURE SelectorInfo (VAR win, xpos, ypos, font: INTEGER);

IMPLEMENTATION

USES M_Sys, M_Strings;


PROCEDURE FontSelector (handle: INTEGER; 
                        CONST msg: STRING;
                        opt: BITSET);
VAR x: CSTRING;
BEGIN
 StrPCopy (x, msg);
 App^.MagicPB^.AddrIn[0]:= ADDR (x);
 App^.MagicPB^.IntIn[0]:= handle;
 App^.MagicPB^.IntIn[1]:= BitsetToWord (opt);
 CallMagic (1500);
END (*FontSelector*);

PROCEDURE FontPSelector (handle, x, y: INTEGER; 
                        CONST msg: STRING;
                        opt: BITSET);
VAR c: CSTRING;
BEGIN
 StrPCopy (c, msg);
 App^.MagicPB^.AddrIn[0]:= ADDR (c);
 App^.MagicPB^.IntIn[0]:= handle;
 App^.MagicPB^.IntIn[1]:= BitsetToWord (opt);
 App^.MagicPB^.IntIn[2]:= x;
 App^.MagicPB^.IntIn[3]:= y;
 CallMagic (1504);
END (*FontSelector*);

PROCEDURE CloseSelector;
BEGIN
 CallMagic (1501);
END (*CloseSelector*);

PROCEDURE SampleSentence (CONST txt: STRING);
VAR x: CSTRING;
BEGIN
 StrPCopy (x, txt);
 App^.MagicPB^.AddrIn[0]:= ADDR (x);
 CallMagic (1502);
END (*SampleSentence*);

PROCEDURE RedrawSelector;
BEGIN
 CallMagic (1503);
END (*RedrawSelector*);

PROCEDURE SelectorInfo (VAR win, xpos, ypos, font: INTEGER);
BEGIN
 CallMagic (1505);
 win:=  App^.MagicPB^.IntOut[0];
 xpos:= App^.MagicPB^.IntOut[1];
 ypos:= App^.MagicPB^.IntOut[2];
 font:= App^.MagicPB^.IntOut[3];
 END (*SelectorInfo*);

END (*M_Fontselector*).
