(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.05.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
UNIT M_Menus;

INTERFACE

USES M_Types;

CONST mCheck =        Bit0; (* Hckchen setzen   *)
      mUncheck =      Bit1; (* Hckchen lschen  *)
      mDisable =      Bit2; (* Eintrag disablen  *)
      mEnable =       Bit3; (* Eintrag freigeben *)
      mSwapDisabled = Bit4; (* Bei den Eintrgen, die in spec.x..spec.h stehen
                             * werden die Disabled-Flags geswapped. Disabled
                             * wird zu nicht disabled und umgekehrt.
                             *)
      mSwapChecked =  Bit5; (* Wie mSwapDisabled, nur mit den CHECKED-Flag *)
      mBell =         Bit6; (* Das Stadler-Flag: Klingeling! *)

TYPE PtrMenupara =      ^MenuParameter;
     MenuParameter =    RECORD
                         tree:          POINTER;
                         key:           tKey;
                         window:        INTEGER;
                         mx, my:        INTEGER;
                         menu, entry:   INTEGER;
                         spec:          tRect;
                         action:        BITSET;
                        END;

TYPE MenuHandler = PROCEDURE (mp: PtrMenupara);

FUNCTION InitMenuline (menu: POINTER; handler: MenuHandler; lines: BOOLEAN): BOOLEAN;
PROCEDURE InstallDeskMenu (menu: POINTER);
PROCEDURE ReleaseDeskMenu;
PROCEDURE DisableDeskMenu;
PROCEDURE EnableDeskMenu;

IMPLEMENTATION

{$I COMPOPT.INC}

USES M_Sys;

FUNCTION InitMenuline (menu: POINTER; handler: MenuHandler;
                       lines: BOOLEAN): BOOLEAN;
VAR x: RECORD
        CASE INTEGER OF
         0: (ptr: POINTER);
         1: (hnd: MenuHandler);
       END;
BEGIN
 x.hnd:= handler;
 App^.MagicPB^.AddrIn[0]:= menu;
 App^.MagicPB^.AddrIn[1]:= x.ptr;
 App^.MagicPB^.IntIn[0]:= ORD (lines);
 CallMagic (1600);
 InitMenuline:= BOOLEAN (App^.MagicPB^.IntOut[0]);
END (*InitMenuline*);

PROCEDURE InstallDeskMenu (menu: POINTER);
BEGIN
 App^.MagicPB^.AddrIn[0]:= menu;
 CallMagic (1601);
END (*InstallDeskMenu*);

PROCEDURE ReleaseDeskMenu;
BEGIN
 CallMagic (1602);
END (*ReleaseDeskMenu*);

PROCEDURE DisableDeskMenu;
BEGIN
 CallMagic (1603);
END (*DisableDeskMenu*);

PROCEDURE EnableDeskMenu;
BEGIN
 CallMagic (1604);
END (*EnableDeskMenu*);

END (*M_Menus*).
