(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGIC        Modular  Applications  GEM  Interface  Cadre           *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 4.00  01.05.1994   (C)1990..1994 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden    *
 * zu widerrufen.                                                       *
 *----------------------------------------------------------------------*)
 
UNIT M_Rsc;

INTERFACE

TYPE    RESOURCE =  POINTER;

FUNCTION LoadRsc (name: STRING; VAR rsc: RESOURCE): BOOLEAN;
FUNCTION RelocRsc (address: POINTER; VAR rsc: RESOURCE): BOOLEAN;
PROCEDURE FreeRsc (VAR rsc: RESOURCE);
FUNCTION GaddrRsc (rsc: RESOURCE; typ, item: INTEGER): POINTER;
PROCEDURE SaddrRsc (rsc: RESOURCE; typ, item: INTEGER; tree: POINTER);
PROCEDURE ObfixRsc (rsc: RESOURCE; tree: POINTER; objc: INTEGER);
 
IMPLEMENTATION

{$I COMPOPT.INC}

USES M_Types, M_Sys, M_Strings;

FUNCTION LoadRsc (name: STRING; VAR rsc: RESOURCE): BOOLEAN;
VAR s: CSTRING;
BEGIN
 StrPCopy (s, name);
 App^.MagicPB^.AddrIn[0]:= ADDR (s);
 CallMagic (1900);
 rsc:= App^.MagicPB^.AddrOut[0];
 LoadRsc:= rsc <> NIL;
END (*LoadRsc*);

FUNCTION RelocRsc (address: POINTER; VAR rsc: RESOURCE): BOOLEAN;
BEGIN
 App^.MagicPB^.AddrIn[0]:= address;
 CallMagic (1901);
 rsc:= App^.MagicPB^.AddrOut[0];
 RelocRsc:= rsc <> NIL;
END (*RelocRsc*);

PROCEDURE FreeRsc (VAR rsc: RESOURCE);
BEGIN
 App^.MagicPB^.AddrIn[0]:= rsc;
 CallMagic (1902);
 rsc:= NIL;
END (*FreeRsc*);

FUNCTION GaddrRsc (rsc: RESOURCE; typ, item: INTEGER): POINTER;
BEGIN
 App^.MagicPB^.AddrIn[0]:= rsc;
 App^.MagicPB^.IntIn[0]:= typ;
 App^.MagicPB^.IntIn[1]:= item;
 CallMagic (1904);
 GaddrRsc:= App^.MagicPB^.AddrOut[0];
END (*GaddrRsc*);

PROCEDURE SaddrRsc (rsc: RESOURCE; typ, item: INTEGER; tree: POINTER);
BEGIN
 App^.MagicPB^.AddrIn[0]:= rsc;
 App^.MagicPB^.AddrIn[1]:= tree;
 App^.MagicPB^.IntIn[0]:= typ;
 App^.MagicPB^.IntIn[1]:= item;
 CallMagic (1905);
END (*SaddrRsc*);

PROCEDURE ObfixRsc (rsc: RESOURCE; tree: POINTER; objc: INTEGER);
BEGIN
 App^.MagicPB^.AddrIn[0]:= rsc;
 App^.MagicPB^.AddrIn[1]:= tree;
 App^.MagicPB^.IntIn[0]:= objc;
 CallMagic (1906);
END (*ObfixRsc*);

END (*M_Rsc*).
